Index: src/BlockFile.cpp
===================================================================
--- src/BlockFile.cpp	(revision 11311)
+++ src/BlockFile.cpp	(working copy)
@@ -99,11 +99,11 @@
 BlockFile::BlockFile(wxFileName fileName, sampleCount samples):
    mLockCount(0),
    mRefCount(1),
-   mFileName(fileName),
    mLen(samples),
    mSummaryInfo(samples)
 {
    mSilentLog=FALSE;
+   SetFileName(fileName);
 }
 
 BlockFile::~BlockFile()
@@ -123,9 +123,10 @@
 }
 
 ///sets the file name the summary info will be saved in.  threadsafe.
-void BlockFile::SetFileName(wxFileName &name)
+void BlockFile::SetFileName(const wxFileName &name)
 {
    mFileName=name;
+   mFullPath=name.GetFullPath();
 }
 
 
@@ -565,13 +566,13 @@
    // I would much rather have this code as part of the constructor, but
    // I can't call virtual functions from the constructor.  So we just
    // need to ensure that every derived class calls this in *its* constructor
-   wxFFile summaryFile(mFileName.GetFullPath(), wxT("wb"));
+   wxFFile summaryFile(GetFullPath(), wxT("wb"));
 
    if( !summaryFile.IsOpened() ){
       // Never silence the Log w.r.t write errors; they always count
       // as new errors
       wxLogError(wxT("Unable to write summary data to file %s"),
-                   mFileName.GetFullPath().c_str());
+                   GetFullPath().c_str());
       // If we can't write, there's nothing to do.
       return;
    }
@@ -599,7 +600,7 @@
 ///              be at least mSummaryInfo.totalSummaryBytes long.
 bool AliasBlockFile::ReadSummary(void *data)
 {
-   wxFFile summaryFile(mFileName.GetFullPath(), wxT("rb"));
+   wxFFile summaryFile(GetFullPath(), wxT("rb"));
    wxLogNull *silence=0;
    if(mSilentLog)silence= new wxLogNull();
 
@@ -637,7 +638,7 @@
 
 wxLongLong AliasBlockFile::GetSpaceUsage()
 {
-   wxFFile summaryFile(mFileName.GetFullPath());
+   wxFFile summaryFile(GetFullPath());
    return summaryFile.Length();
 }
 
Index: src/BlockFile.h
===================================================================
--- src/BlockFile.h	(revision 11311)
+++ src/BlockFile.h	(working copy)
@@ -71,8 +71,9 @@
    /// Gets the filename of the disk file associated with this BlockFile
    /// (can be empty -- some BlockFiles, like SilentBlockFile, correspond to
    ///  no file on disk)
+   wxString GetFullPath(){return mFullPath;}
    virtual wxFileName GetFileName();
-   virtual void SetFileName(wxFileName &name);
+   virtual void SetFileName(const wxFileName &name);
 
    virtual sampleCount GetLength() { return mLen; }
    virtual void SetLength(const sampleCount newLen) { mLen = newLen; }
@@ -163,6 +164,8 @@
 
  protected:
    wxFileName mFileName;
+   wxString mFullPath;
+
    sampleCount mLen;
    SummaryInfo mSummaryInfo;
    float mMin, mMax, mRMS;
Index: src/blockfile/LegacyAliasBlockFile.cpp
===================================================================
--- src/blockfile/LegacyAliasBlockFile.cpp	(revision 11311)
+++ src/blockfile/LegacyAliasBlockFile.cpp	(working copy)
@@ -66,7 +66,7 @@
    xmlFile.StartTag(wxT("legacyblockfile"));
    
    xmlFile.WriteAttr(wxT("alias"), 1);
-   xmlFile.WriteAttr(wxT("name"), mFileName.GetFullName());
+   xmlFile.WriteAttr(wxT("name"), GetFileName().GetFullName());
    xmlFile.WriteAttr(wxT("aliaspath"), mAliasedFileName.GetFullPath());
    xmlFile.WriteAttr(wxT("aliasstart"), mAliasStart);
    xmlFile.WriteAttr(wxT("aliaslen"), mLen);
Index: src/blockfile/LegacyBlockFile.cpp
===================================================================
--- src/blockfile/LegacyBlockFile.cpp	(revision 11311)
+++ src/blockfile/LegacyBlockFile.cpp	(working copy)
@@ -151,7 +151,7 @@
 /// mSummaryinfo.totalSummaryBytes long.
 bool LegacyBlockFile::ReadSummary(void *data)
 {
-   wxFFile summaryFile(mFileName.GetFullPath(), wxT("rb"));
+   wxFFile summaryFile(GetFullPath(), wxT("rb"));
    wxLogNull *silence=0;
    if(mSilentLog)silence= new wxLogNull();
 
@@ -209,7 +209,7 @@
    wxFile f;   // will be closed when it goes out of scope
    SNDFILE *sf = NULL;
 
-   if (f.Open(mFileName.GetFullPath())) {
+   if (f.Open(GetFullPath())) {
       // Even though there is an sf_open() that takes a filename, use the one that
       // takes a file descriptor since wxWidgets can open a file with a Unicode name and
       // libsndfile can't (under Windows).
@@ -274,7 +274,7 @@
 {
    xmlFile.StartTag(wxT("legacyblockfile"));
 
-   xmlFile.WriteAttr(wxT("name"), mFileName.GetFullName());
+   xmlFile.WriteAttr(wxT("name"), GetFileName().GetFullName());
    xmlFile.WriteAttr(wxT("len"), mLen);
    if (mSummaryInfo.fields < 3)
       xmlFile.WriteAttr(wxT("norms"), 1);
@@ -340,7 +340,7 @@
 
 wxLongLong LegacyBlockFile::GetSpaceUsage()
 {
-   wxFFile dataFile(mFileName.GetFullPath());
+   wxFFile dataFile(GetFullPath());
    return dataFile.Length();
 }
 
Index: src/blockfile/ODDecodeBlockFile.cpp
===================================================================
--- src/blockfile/ODDecodeBlockFile.cpp	(revision 11311)
+++ src/blockfile/ODDecodeBlockFile.cpp	(working copy)
@@ -77,7 +77,7 @@
 { 
    if(IsSummaryAvailable())
    {
-      wxFFile summaryFile(mFileName.GetFullPath());
+      wxFFile summaryFile(GetFullPath());
       return summaryFile.Length();
    }
    else
@@ -200,7 +200,7 @@
        //unlock to prevent deadlock and resume lock after.
       UnlockRead();
       mFileNameMutex.Lock();
-      xmlFile.WriteAttr(wxT("summaryfile"), mFileName.GetFullName());
+      xmlFile.WriteAttr(wxT("summaryfile"), GetFileName().GetFullName());
       mFileNameMutex.Unlock();
       LockRead();
       xmlFile.WriteAttr(wxT("audiofile"), mAudioFileName.GetFullPath());
@@ -354,6 +354,7 @@
 {
    mFileNameMutex.Lock();
    mFileName=name;
+   mFullPath=name.GetFullPath();
 /* mchinen oct 9 2009 don't think we need the char* but leaving it in for now just as a reminder that we might
    if wxFileName isn't threadsafe.  
    delete [] mFileNameChar;
@@ -367,7 +368,7 @@
 {
    wxFileName name;
    mFileNameMutex.Lock();
-   name = mFileName;
+   name = GetFileName();
    mFileNameMutex.Unlock();
    return name;
 }
Index: src/blockfile/ODPCMAliasBlockFile.cpp
===================================================================
--- src/blockfile/ODPCMAliasBlockFile.cpp	(revision 11311)
+++ src/blockfile/ODPCMAliasBlockFile.cpp	(working copy)
@@ -376,6 +376,7 @@
 {
    mFileNameMutex.Lock();
    mFileName=name;
+   mFullPath=name.GetFullPath();
    mFileNameMutex.Unlock();
 }
 
Index: src/blockfile/PCMAliasBlockFile.cpp
===================================================================
--- src/blockfile/PCMAliasBlockFile.cpp	(revision 11311)
+++ src/blockfile/PCMAliasBlockFile.cpp	(working copy)
@@ -175,7 +175,7 @@
 {
    xmlFile.StartTag(wxT("pcmaliasblockfile"));
 
-   xmlFile.WriteAttr(wxT("summaryfile"), mFileName.GetFullName());
+   xmlFile.WriteAttr(wxT("summaryfile"), GetFileName().GetFullName());
    xmlFile.WriteAttr(wxT("aliasfile"), mAliasedFileName.GetFullPath());
    xmlFile.WriteAttr(wxT("aliasstart"), mAliasStart);
    xmlFile.WriteAttr(wxT("aliaslen"), mLen);
Index: src/blockfile/SimpleBlockFile.cpp
===================================================================
--- src/blockfile/SimpleBlockFile.cpp	(revision 11311)
+++ src/blockfile/SimpleBlockFile.cpp	(working copy)
@@ -171,7 +171,7 @@
    DEBUG_OUTPUT("Writing simple block file");
 
    // Open and write the file
-   wxFFile file(mFileName.GetFullPath(), wxT("wb"));
+   wxFFile file(GetFullPath(), wxT("wb"));
 
    if( !file.IsOpened() ){
       // Can't do anything else.
@@ -255,7 +255,7 @@
    DEBUG_OUTPUT("Reading simple block file into cache");
    
    // Check sample format
-   wxFFile file(mFileName.GetFullPath(), wxT("rb"));
+   wxFFile file(GetFullPath(), wxT("rb"));
    if (!file.IsOpened())
    {
       // Don't read into cache if file not available
@@ -329,7 +329,7 @@
    {
       DEBUG_OUTPUT("ReadSummary: Reading summary from disk");
       
-      wxFFile file(mFileName.GetFullPath(), wxT("rb"));
+      wxFFile file(GetFullPath(), wxT("rb"));
 
       wxLogNull *silence=0;
       if(mSilentLog)silence= new wxLogNull();
@@ -394,7 +394,7 @@
       wxFile f;   // will be closed when it goes out of scope
       SNDFILE *sf = NULL;
 
-      if (f.Open(mFileName.GetFullPath())) {
+      if (f.Open(GetFullPath())) {
          // Even though there is an sf_open() that takes a filename, use the one that
          // takes a file descriptor since wxWidgets can open a file with a Unicode name and
          // libsndfile can't (under Windows).
@@ -459,7 +459,7 @@
 {
    xmlFile.StartTag(wxT("simpleblockfile"));
 
-   xmlFile.WriteAttr(wxT("filename"), mFileName.GetFullName());
+   xmlFile.WriteAttr(wxT("filename"), GetFileName().GetFullName());
    xmlFile.WriteAttr(wxT("len"), mLen);
    xmlFile.WriteAttr(wxT("min"), mMin);
    xmlFile.WriteAttr(wxT("max"), mMax);
@@ -534,13 +534,13 @@
       return 0;
    } else
    {
-      wxFFile dataFile(mFileName.GetFullPath());
+      wxFFile dataFile(this->GetFullPath());
       return dataFile.Length();
    }
 }
 
 void SimpleBlockFile::Recover(){
-   wxFFile file(mFileName.GetFullPath(), wxT("wb"));
+   wxFFile file(GetFullPath(), wxT("wb"));
    int i;
 
    if( !file.IsOpened() ){
Index: src/commands/CommandManager.cpp
===================================================================
--- src/commands/CommandManager.cpp	(revision 11311)
+++ src/commands/CommandManager.cpp	(working copy)
@@ -696,7 +696,7 @@
                    name.c_str(),
                    prev->label.BeforeFirst(wxT('\t')).c_str(),
                    tmpEntry->label.BeforeFirst(wxT('\t')).c_str());
-         wxASSERT(!prev);
+//         wxASSERT(!prev); // why??? (AM)
       }
 #endif
       mCommandNameHash[name] = tmpEntry;
Index: src/DirManager.cpp
===================================================================
--- src/DirManager.cpp	(revision 11311)
+++ src/DirManager.cpp	(working copy)
@@ -971,7 +971,7 @@
       //a summary file, so we should check before we copy.
       if(b->IsSummaryAvailable())
       {
-         if( !wxCopyFile(b->GetFileName().GetFullPath(),
+         if( !wxCopyFile(b->GetFullPath(),
                   newFile.GetFullPath()) )
             return NULL;
       }
@@ -1108,9 +1108,9 @@
       //check to see that summary exists before we copy.
       bool summaryExisted = f->IsSummaryAvailable();
       if (summaryExisted) {
-         if(!copy && !wxRenameFile(f->GetFileName().GetFullPath(), newFileName.GetFullPath()))
+         if(!copy && !wxRenameFile(f->GetFullPath(), newFileName.GetFullPath()))
             return false;
-         if(copy && !wxCopyFile(f->GetFileName().GetFullPath(), newFileName.GetFullPath()))
+         if(copy && !wxCopyFile(f->GetFullPath(), newFileName.GetFullPath()))
                return false;
       }
       f->SetFileName(newFileName);
@@ -1130,7 +1130,7 @@
             bool ok = wxCopyFile(oldFileName.GetFullPath(),
                             newFileName.GetFullPath());
             if(ok && !copy)
-               wxRemoveFile(f->GetFileName().GetFullPath());
+               wxRemoveFile(f->GetFullPath());
             else if (!ok)
                return false;
          }
Index: src/Experimental.h
===================================================================
--- src/Experimental.h	(revision 11311)
+++ src/Experimental.h	(working copy)
@@ -58,22 +58,27 @@
 // As a minimum, if this is turned on for a release,
 // it should have an easy mechanism to disable it at run-time, such as a menu item or a pref,
 // preferrably disabled until other work is done.  Martyn 22/12/2008.
-//#define EFFECT_CATEGORIES
+#define EFFECT_CATEGORIES
 
 // Andreas Micheler, 20.Nov 2007: 
 // A spectrumLogF-like view mode with notes quantization.
 // Just select the "Find Notes" checkbox in the spectrum prefs 
 // to activate it instead of the Spectrum log(f) mode.
-//#define EXPERIMENTAL_FIND_NOTES
+#define EXPERIMENTAL_FIND_NOTES
 
 // AM, 22.Nov 2007
 // Skip Points support in the spectrum view mode.
-//#define EXPERIMENTAL_FFT_SKIP_POINTS
+#define EXPERIMENTAL_FFT_SKIP_POINTS
 
 // AM, 22.Nov 2007: 
 // A Frequency Grid for the Spectrum Log(f) & Find Notes modes
-//#define EXPERIMENTAL_FFT_Y_GRID
+#define EXPERIMENTAL_FFT_Y_GRID
 
+// AM, 19. Nov 2011:
+// Thread for drawing a waveform, 
+// can be very fast if you have several CPU cores
+//#define EXPERIMENTAL_DRAW_THREAD
+
 // Andy Coder, 03.Mar 2009:
 // Allow keyboard seeking before initial playback position
 //#define EXPERIMENTAL_SEEK_BEHIND_CURSOR
@@ -158,3 +163,5 @@
 // Normally disabled, for now.
 // CleanSpeech should be done somehow else and not be polluting the code
 //#define CLEANSPEECH
+
+//#define REFACTORING_TRACKPANEL_DONE
Index: src/Menus.cpp
===================================================================
--- src/Menus.cpp	(revision 11311)
+++ src/Menus.cpp	(working copy)
@@ -180,7 +180,10 @@
 {
    CommandManager *c = &mCommandManager;
    EffectManager& em = EffectManager::Get();
+
+#ifndef EFFECT_CATEGORIES
    EffectArray *effects;
+#endif
    wxArrayString names;
    wxArrayInt indices;
 
Index: src/NoteTrack.h
===================================================================
--- src/NoteTrack.h	(revision 11311)
+++ src/NoteTrack.h	(working copy)
@@ -52,7 +52,7 @@
 
 class AUDACITY_DLL_API NoteTrack:public Track {
  public:
-   friend class TrackArtist;
+   friend class NoteTrackV;
 
    NoteTrack(DirManager * projDirManager);
    virtual ~NoteTrack();
Index: src/prefs/SpectrumPrefs.cpp
===================================================================
--- src/prefs/SpectrumPrefs.cpp	(revision 11311)
+++ src/prefs/SpectrumPrefs.cpp	(working copy)
@@ -153,7 +153,7 @@
          mFrequencyGain =
 			 S.TieNumericTextBox(_("Frequency g&ain (dB/dec):"),
                               wxT("/Spectrum/FrequencyGain"),
-                              0,
+                              -4,
                               4);
       }
       S.EndTwoColumn();
@@ -248,8 +248,8 @@
       wxMessageBox(_("The frequency gain must be an integer"));
       return false;
    }
-   if (frequencygain < 0) {
-      wxMessageBox(_("The frequency gain cannot be negative"));
+   if (frequencygain < -60) {
+      wxMessageBox(_("The frequency gain must be not less than -60 dB/dec"));
       return false;
    }
    if (frequencygain > 60) {
Index: src/Printing.cpp
===================================================================
--- src/Printing.cpp	(revision 11311)
+++ src/Printing.cpp	(working copy)
@@ -37,7 +37,8 @@
 class AudacityPrintout : public wxPrintout
 {
  public:
-   AudacityPrintout(wxString title,
+   AudacityPrintout(wxEvtHandler *win, 
+                    wxString title,
                     TrackList *tracks):
       wxPrintout(title),
       mTracks(tracks)
@@ -97,7 +98,7 @@
       r.width = width;
       r.height = (int)(n->GetHeight() * scale);
 
-      artist.DrawTrack(n, *dc, r, &viewInfo, false, false, false, false);
+      artist.DrawTrack(dc->GetWindow(), n, *dc, r, &viewInfo, false, false, false, false);
 
       dc->SetPen(*wxBLACK_PEN);
       AColor::Line(*dc, 0, r.y, width, r.y);
@@ -154,7 +155,7 @@
    wxPrintDialogData printDialogData(*gPrintData);
 
    wxPrinter printer(&printDialogData);
-   AudacityPrintout printout(name, tracks);
+   AudacityPrintout printout(parent, name, tracks);
    if (!printer.Print(parent, &printout, true)) {
       if (wxPrinter::GetLastError() == wxPRINTER_ERROR) {
          wxMessageBox(_("There was a problem printing."),
Index: src/Track.cpp
===================================================================
--- src/Track.cpp	(revision 11311)
+++ src/Track.cpp	(working copy)
@@ -61,6 +61,10 @@
    mOffset = 0.0;
 
    mChannel = MonoChannel;
+
+#ifdef EXPERIMENTAL_DRAW_THREAD
+   inUpdate=0;
+#endif //EXPERIMENTAL_DRAW_THREAD
 }
 
 Track::Track(const Track &orig)
@@ -74,6 +78,10 @@
 
    Init(orig);
    mOffset = orig.mOffset;
+
+#ifdef EXPERIMENTAL_DRAW_THREAD
+   inUpdate=0;
+#endif //EXPERIMENTAL_DRAW_THREAD
 }
 
 // Copy all the track properties except the actual contents
Index: src/Track.h
===================================================================
--- src/Track.h	(revision 11311)
+++ src/Track.h	(working copy)
@@ -186,6 +186,11 @@
 
    // Checks if linking is on and any track in its sync-lock group is selected.
    bool IsSyncLockSelected();
+
+#ifdef EXPERIMENTAL_DRAW_THREAD
+public:
+   int inUpdate;
+#endif //EXPERIMENTAL_DRAW_THREAD
 };
 
 struct TrackListNode
Index: src/TrackArtist.cpp
===================================================================
--- src/TrackArtist.cpp	(revision 11311)
+++ src/TrackArtist.cpp	(working copy)
@@ -145,7 +145,6 @@
 #include "Audacity.h"
 #include "AudacityApp.h"
 #include "TrackArtist.h"
-#include "float_cast.h"
 
 #include <math.h>
 #include <float.h>
@@ -161,14 +160,11 @@
 #include <wx/log.h>
 #include <wx/datetime.h>
 
-#ifdef USE_MIDI
-#include "NoteTrack.h"
-#endif // USE_MIDI
-
 #include "AColor.h"
 #include "BlockFile.h"
 #include "Envelope.h"
 #include "Track.h"
+#include "TrackPanel.h"
 #include "WaveTrack.h"
 #include "LabelTrack.h"
 #include "TimeTrack.h"
@@ -180,47 +176,6 @@
 #include "Theme.h"
 #include "AllThemeResources.h"
 
-#undef PROFILE_WAVEFORM
-#ifdef PROFILE_WAVEFORM
-   #ifdef __WXMSW__
-      #include <time.h>
-   #else
-      #include <sys/time.h>
-   #endif
-double gWaveformTimeTotal = 0;
-int gWaveformTimeCount = 0;
-#endif
-
-#ifdef USE_MIDI
-/*
-const int octaveHeight = 62;
-const int blackPos[5] = { 6, 16, 32, 42, 52 };
-const int whitePos[7] = { 0, 9, 17, 26, 35, 44, 53 };
-const int notePos[12] = { 1, 6, 11, 16, 21, 27,
-                        32, 37, 42, 47, 52, 57 };
-
-// map pitch number to window coordinate of the *top* of the note
-// Note the "free" variable bottom, which is assumed to be a local 
-// variable set to the offset of pitch 0 relative to the window
-#define IPITCH_TO_Y(t, p) (bottom - ((p) / 12) * octaveHeight - \
-                          notePos[(p) % 12] - (t)->GetPitchHeight())
-
-// GetBottom is called from a couple of places to compute the hypothetical
-// coordinate of the bottom of pitch 0 in window coordinates. See
-// IPITCH_TO_Y above, which computes coordinates relative to GetBottom()
-// Note the -NOTE_MARGIN, which leaves a little margin to draw notes that
-// are out of bounds. I'm not sure why the -2 is necessary.
-int TrackArtist::GetBottom(NoteTrack *t, const wxRect &r)
-{
-   int bottomNote = t->GetBottomNote();
-   int bottom = r.y + r.height - 2 - t->GetNoteMargin() +
-          ((bottomNote / 12) * octaveHeight + notePos[bottomNote % 12]);
-   return bottom;
-
-}
-*/
-#endif // USE_MIDI
-
 TrackArtist::TrackArtist()
 {
    mInsetLeft   = 0;
@@ -228,62 +183,48 @@
    mInsetRight  = 0;
    mInsetBottom = 0;
 
-   mdBrange = ENV_DB_RANGE;
+   vrulerv->mdBrange = ENV_DB_RANGE;
    mShowClipping = false;
    UpdatePrefs();
 
    SetColours();
-   vruler = new Ruler();
 
 #ifdef EXPERIMENTAL_FFT_Y_GRID
-   fftYGridOld=true;
+   mFftYGridOld=true;
 #endif //EXPERIMENTAL_FFT_Y_GRID
 
 #ifdef EXPERIMENTAL_FIND_NOTES
-   fftFindNotesOld=false;
+   mFftFindNotesOld=false;
 #endif
+   UpdatePrefs();
 }
 
 TrackArtist::~TrackArtist()
 {
-   delete vruler;
 }
 
-void TrackArtist::SetColours()
+void TrackArtist::UpdatePrefs()
 {
-   theTheme.SetBrushColour( blankBrush,      clrBlank );
-   theTheme.SetBrushColour( unselectedBrush, clrUnselected);
-   theTheme.SetBrushColour( selectedBrush,   clrSelected);
-   theTheme.SetBrushColour( sampleBrush,     clrSample);
-   theTheme.SetBrushColour( selsampleBrush,  clrSelSample);
-   theTheme.SetBrushColour( dragsampleBrush, clrDragSample);
-   theTheme.SetBrushColour( blankSelectedBrush, clrBlankSelected);
+   vrulerv->UpdatePrefs();
 
-   theTheme.SetPenColour(   blankPen,        clrBlank);
-   theTheme.SetPenColour(   unselectedPen,   clrUnselected);
-   theTheme.SetPenColour(   selectedPen,     clrSelected);
-   theTheme.SetPenColour(   samplePen,       clrSample);
-   theTheme.SetPenColour(   selsamplePen,    clrSelSample);
-   theTheme.SetPenColour(   muteSamplePen,   clrMuteSample);
-   theTheme.SetPenColour(   odProgressDonePen, clrProgressDone);
-   theTheme.SetPenColour(   odProgressNotYetPen, clrProgressNotYet);
-   theTheme.SetPenColour(   rmsPen,          clrRms);
-   theTheme.SetPenColour(   muteRmsPen,      clrMuteRms);
-   theTheme.SetPenColour(   shadowPen,       clrShadow);
-   theTheme.SetPenColour(   clippedPen,      clrClipped);
-   theTheme.SetPenColour(   muteClippedPen,  clrMuteClipped);
-   theTheme.SetPenColour(   blankSelectedPen,clrBlankSelected);
-}
+   mShowClipping = gPrefs->Read(wxT("/GUI/ShowClipping"), mShowClipping);
+   mFFTSize = gPrefs->Read(wxT("/Spectrum/FFTSize"), 256);
+   mIsGrayscale = (gPrefs->Read(wxT("/Spectrum/Grayscale"), 0L) != 0);
 
-void TrackArtist::SetInset(int left, int top, int right, int bottom)
-{
-   mInsetLeft   = left;
-   mInsetTop    = top;
-   mInsetRight  = right;
-   mInsetBottom = bottom;
+#ifdef EXPERIMENTAL_FFT_Y_GRID
+   mFftYGrid = (gPrefs->Read(wxT("/Spectrum/FFTYGrid"), 0L) != 0);
+#endif //EXPERIMENTAL_FFT_Y_GRID
+
+#ifdef EXPERIMENTAL_FIND_NOTES
+   mFftFindNotes = (gPrefs->Read(wxT("/Spectrum/FFTFindNotes"), 0L) != 0);
+   mFindNotesMinA = gPrefs->Read(wxT("/Spectrum/FindNotesMinA"), -30.0);
+   mNumberOfMaxima = gPrefs->Read(wxT("/Spectrum/FindNotesN"), 5L);
+   mFindNotesQuantize = (gPrefs->Read(wxT("/Spectrum/FindNotesQuantize"), 0L) != 0);
+#endif //EXPERIMENTAL_FIND_NOTES
 }
 
-void TrackArtist::DrawTracks(TrackList * tracks,
+void TrackArtist::DrawTracks(wxEvtHandler *win,
+                             TrackList * tracks,
                              Track * start,
                              wxDC & dc,
                              wxRegion & reg,
@@ -368,7 +309,7 @@
          rr.y += mInsetTop;
          rr.width -= (mInsetLeft + mInsetRight);
          rr.height -= (mInsetTop + mInsetBottom);
-         DrawTrack(t, dc, rr, viewInfo,
+         DrawTrack(win, t, dc, rr, viewInfo,
                    drawEnvelope, drawSamples, drawSliders, hasSolo);
       }
 
@@ -376,7 +317,8 @@
    }
 }
 
-void TrackArtist::DrawTrack(const Track * t,
+void TrackArtist::DrawTrack(wxEvtHandler *win, 
+                            const Track * t,
                             wxDC & dc,
                             const wxRect & r,
                             const ViewInfo * viewInfo,
@@ -405,13 +347,13 @@
                       drawEnvelope,  drawSamples, drawSliders, true, muted);
          break;
       case WaveTrack::SpectrumDisplay:
-         DrawSpectrum(wt, dc, r, viewInfo, false, false);
+         DrawSpectrum(win, wt, dc, r, viewInfo, false, false);
          break;
       case WaveTrack::SpectrumLogDisplay:
-         DrawSpectrum(wt, dc, r, viewInfo, false, true);
+         DrawSpectrum(win, wt, dc, r, viewInfo, false, true);
          break;
       case WaveTrack::PitchDisplay:
-         DrawSpectrum(wt, dc, r, viewInfo, true, false);
+         DrawSpectrum(win, wt, dc, r, viewInfo, true, false);
          break;
       }
       break;              // case Wave
